Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::Base64_Encoder Class Referencefinal

`#include <b64_filt.h>`

Inheritance diagram for Botan::Base64_Encoder:

## Public Member Functions
virtual bool | attachable ()
| Base64_Encoder (bool breaks=false, size_t length=72, bool t_n=false)
void | end_msg () override
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t input[], size_t length) override

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

This class represents a Base64 encoder.

Definition at line 18 of file b64_filt.h.

## Constructor & Destructor Documentation

Botan::Base64_Encoder::Base64_Encoder | ( | bool | breaks = `false`,
|  | size_t | length = `72`,
|  | bool | t_n = `false`
| ) |  |

Create a base64 encoder.

Parameters

  breaks | whether to use line breaks in the output
  length | the length of the lines of the output
  t_n | whether to use a trailing newline

Definition at line 19 of file b64_filt.cpp.

19 :
20 m_line_length(breaks ? length : 0),
21 m_trailing_newline(t_n && breaks),
22 m_in(48),
23 m_out(64),
24 m_position(0),
25 m_out_position(0)
26 {
27 }

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

void Botan::Base64_Encoder::end_msg | ( |  | ) |
| override virtual

Inform the Encoder that the current message shall be closed.

Reimplemented from Botan::Filter.

Definition at line 103 of file b64_filt.cpp.

References Botan::Filter::send().

104 {
105 encode_and_send(m_in.data(), m_position, true);
106
107 if(m_trailing_newline || (m_out_position && m_line_length))
108 send('\n');
109
110 m_out_position = m_position = 0;
111 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

std::string Botan::Base64_Encoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 21 of file b64_filt.h.

21 { return "Base64_Encoder"; }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

void Botan::Base64_Encoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Input a part of a message to the encoder.

Parameters

  input | the message to input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 80 of file b64_filt.cpp.

References Botan::buffer_insert(), and Botan::copy_mem().

81 {
82 buffer_insert(m_in, m_position, input, length);
83 if(m_position + length >= m_in.size())
84 {
85 encode_and_send(m_in.data(), m_in.size());
86 input += (m_in.size() - m_position);
87 length -= (m_in.size() - m_position);
88 while(length >= m_in.size())
89 {
90 encode_and_send(input, m_in.size());
91 input += m_in.size();
92 length -= m_in.size();
93 }
94 copy_mem(m_in.data(), input, length);
95 m_position = 0;
96 }
97 m_position += length;
98 }
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68
Botan::buffer_insert
size_t buffer_insert(std::vector< T, Alloc > &buf, size_t buf_offset, const T input[], size_t input_length)
Definition: secmem.h:133

The documentation for this class was generated from the following files:

- src/lib/filters/codec_filt/b64_filt.h
- src/lib/filters/codec_filt/b64_filt.cpp